#include "hardware.h"

// -------- BLUETOOTH DEFINES -------
#define USE_BLUETOOTH	rprintfInit( &BluetoothSendByte )

// -------- SSC-32 DEFINES -------
#define USE_SSC32		rprintfInit( &SSC32SendByte )

// -------- Function Definations --------
void MoveServo( int servoNum, int pulse );

// -------- Start Globals -------
// -------- End Globals -------

// Initialise the hardware
void appInitHardware( void) {

	initHardware();
}

// Initialise the software
TICK_COUNT appInitSoftware( TICK_COUNT loopStart ){

	// -------- Start Switch/Button-------
	while( !SWITCH_pressed( &button ) );
	// -------- End   Switch/Button-------
	
	return 0;
}

// This is the main loop
TICK_COUNT appControl( LOOP_COUNT loopCount, TICK_COUNT loopStart ) {

	// -------- Start Sharp GP2-------
	// Read the Sharp GP2 and store the result in Top.distance.cm
	distanceRead( Top );

	USE_BLUETOOTH;
	rprintf( "Distance=%u", Top.distance.cm );
	rprintfCRLF();
	// -------- End   Sharp GP2-------

	// -------- Start
	for( int i = 0; i < 32; i++ ) {

		MoveServo( i, 1500 );
	}

	return 20;
}

void MoveServo( int servoNum, int pulse ) {

	USE_SSC32;

	rprintf( "#%d P%d\r", servoNum, pulse );
}
