/*
		This file has been auto-generated by WebbotLib tools V1.1
				** DO NOT MODIFY BY HAND **
*/
#ifndef _HARDWARE_H_
#define _HARDWARE_H_
#include "xhardware.h"
// Type of interrupt handler to use for uart interrupts.
// Do not change unless you know what you're doing.
#ifndef UART_INTERRUPT_HANDLER
#define UART_INTERRUPT_HANDLER	ISR
#endif

// ------------------- uart1 -------------------

// Create hardware UART uart1
HW_UART _uart1 = MAKE_UART_BUFFERED(null,null,UCSR1A,UCSR1B,UBRR1L,UBRR1H,UDR1,null,BV(U2X1),D2,D3,&uart1GetByte,&uart1SendByte);

// Create a routine to write bytes to uart1
// You can set rprintf to use it by calling rprintfInit(&uart1SendByte)
MAKE_WRITER(uart1SendByte){
	return uartSendByte(uart1,byte);
}

// Create a routine to read a byte from uart1
// Returns -1 if there was no data
MAKE_READER( uart1GetByte){
	return uartGetByte(uart1);
}

#ifndef USART1_TX_vect
# error Uart1 Tx complete vector undefined
#else
UART_INTERRUPT_HANDLER(USART1_TX_vect){
	uartTransmitService(uart1);
}
#endif

#ifndef USART1_RX_vect
# error Uart1 Rx complete vector undefined
#else
UART_INTERRUPT_HANDLER(USART1_RX_vect){
	uartReceiveService(uart1);
}
#endif

// ------------------- Bluetooth -------------------

// Create hardware UART Bluetooth
HW_UART _Bluetooth = MAKE_UART_BUFFERED(null,null,UCSR0A,UCSR0B,UBRR0L,UBRR0H,UDR0,null,BV(U2X0),E0,E1,&BluetoothGetByte,&BluetoothSendByte);

// Create a routine to write bytes to Bluetooth
// You can set rprintf to use it by calling rprintfInit(&BluetoothSendByte)
MAKE_WRITER(BluetoothSendByte){
	return uartSendByte(Bluetooth,byte);
}

// Create a routine to read a byte from Bluetooth
// Returns -1 if there was no data
MAKE_READER( BluetoothGetByte){
	return uartGetByte(Bluetooth);
}

#ifndef USART0_TX_vect
# error Uart0 Tx complete vector undefined
#else
UART_INTERRUPT_HANDLER(USART0_TX_vect){
	uartTransmitService(Bluetooth);
}
#endif

#ifndef USART0_RX_vect
# error Uart0 Rx complete vector undefined
#else
UART_INTERRUPT_HANDLER(USART0_RX_vect){
	uartReceiveService(Bluetooth);
}
#endif

// ------------------- SSC32 -------------------

// Create hardware UART SSC32
HW_UART _SSC32 = MAKE_UART_BUFFERED(null,null,UCSR2A,UCSR2B,UBRR2L,UBRR2H,UDR2,null,BV(U2X2),H0,H1,&SSC32GetByte,&SSC32SendByte);

// Create a routine to write bytes to SSC32
// You can set rprintf to use it by calling rprintfInit(&SSC32SendByte)
MAKE_WRITER(SSC32SendByte){
	return uartSendByte(SSC32,byte);
}

// Create a routine to read a byte from SSC32
// Returns -1 if there was no data
MAKE_READER( SSC32GetByte){
	return uartGetByte(SSC32);
}

#ifndef USART2_TX_vect
# error Uart2 Tx complete vector undefined
#else
UART_INTERRUPT_HANDLER(USART2_TX_vect){
	uartTransmitService(SSC32);
}
#endif

#ifndef USART2_RX_vect
# error Uart2 Rx complete vector undefined
#else
UART_INTERRUPT_HANDLER(USART2_RX_vect){
	uartReceiveService(SSC32);
}
#endif

// ----------- Define the ADC channels ----------
const uint8_t NUM_ADC_CHANNELS = 16;
const uint16_t PROGMEM AVcc_MV = 5000;

// ----------- My devices -----------------------
SWITCH button = MAKE_SWITCH(G5);
Sharp_GP2D12 Top = MAKE_Sharp_GP2D12(ADC0);

// ----------- Initialise built in devices ------
void sysInitHardware(void){
	SWITCH_init(&button);
	uartInit(uart1,115200);
}

// ----------- Initialise my added devices ------
void initHardware(void){
	setErrorLog(&BluetoothSendByte);
	rprintfInit(&BluetoothSendByte);
	uartInit(Bluetooth,115200);
	distanceInit(Top);
	uartInit(SSC32,38400);
}
// ----------- Register the statusLED -----------
void registerLED(void){
	statusLEDregister(B6,false);
}

// ----------- Ports are configured on the fly --
void configure_ports(void){
}

#endif
